(******************************************************************************
 * ACExtEdit                                                                  *
 *                                                                            *
 * Modifiche                                                                  *
 * -------------------------------------------------------------------------- *
 * Sabato, 03/Gennaio/2003                                                    *
 *         Il componente prima veniva ereditato da "TEdit", ora da            *
 "         "TAcEditBox", in questo modo il testo puo' essere allineato anche  *
 *         al centro                                                          *
 ******************************************************************************)
unit ACExtEdit;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AcEditBox;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACExtEdit = class(TAcEditBox)
  private
    { Private declarations }
    Pnl      : TShape;
    F_Bordo  : TColor;
    F_Offset : Integer;
  protected
    { Protected declarations }

    procedure CMMouseEnter(Var Msg : TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(Var Msg : TMessage); message CM_MOUSELEAVE;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  published
    { Published declarations }
    Property BorderColor : TColor Read F_Bordo Write F_Bordo;
    Property OffSet : Integer Read F_Offset Write F_Offset;
  end;

(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
 implementation

(******************************************************************************
 * CMMouseEnter                                                               *
 ******************************************************************************)
procedure TACExtEdit.CMMouseEnter(Var Msg : TMessage);
Begin
  Inherited;
  Pnl.Left := Left - OffSet;
  Pnl.Top := Top - OffSet;
  Pnl.Width := Width + OffSet*2;
  Pnl.Height := Height + OffSet*2;
  Pnl.Parent := Parent;
  Pnl.Pen.Color := BorderColor;
  Pnl.Visible:=True;
End;

(******************************************************************************
 * CMMouseLeave                                                               *
 ******************************************************************************)
procedure TACExtEdit.CMMouseLeave(Var Msg : TMessage);
Begin
  Pnl.Visible:=False;
  Inherited;
End;

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACExtEdit.Create(AOwner: TComponent);
Begin
 Inherited;
 Alignment := taLeftJustify;
 Pnl := TShape.Create(Self);
 Pnl.Brush.Style := bsClear;
 OffSet := 2;
 Pnl.Left := Left - OffSet;
 Pnl.Top := Top - OffSet;
 Pnl.Width := Width + OffSet*2;
 Pnl.Height := Height + OffSet*2;
 Pnl.Visible:=False;

End;

(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TACExtEdit.Destroy;
Begin
  Pnl.Free;
  Inherited;
End;

end.
