(******************************************************************************
 * ACTrLabel                                                                  *
 ******************************************************************************)
unit ACTrLabel;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACTrLabel = class(TCustomLabel)
  private
    { Private declarations }
    Clr1,
    Clr2 : TColor;
  protected
    { Protected declarations }
    Procedure Disegna_Fondo;
  public
    { Public declarations }
    Procedure SetColor1(x:TColor);
    Procedure SetColor2(x:TColor);
    Procedure Paint; Override;
    procedure DoDrawText(var Rect: TRect; Flags: Word);
    constructor Create(AOwner: TComponent); Override;
  published
    { Published declarations }
    property Color_Start : TColor Read Clr1 Write SetColor1;
    property Color_End   : TColor Read Clr2 Write SetColor2;
    Property Caption;
    Property Font;
    Property AutoSize;
  end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses AcFunzioni_Grafiche;

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACTrLabel.Create(AOwner: TComponent);
Begin
  Inherited;
  Color_Start := clActiveCaption;
  Color_End   := clBtnFace;
  //Trasparent := True;

End;

(******************************************************************************
 * SetColor1                                                                  *
 ******************************************************************************)
Procedure TACTrLabel.SetColor1(x:TColor);
Begin
  Clr1 := x;
  Invalidate;
End;

(******************************************************************************
 * SetColor2                                                                  *
 ******************************************************************************)
Procedure TACTrLabel.SetColor2(x:TColor);
Begin
  Clr2 := x;
  Invalidate;
End;

(******************************************************************************
 * DoDrawText                                                                 *
 ******************************************************************************)
procedure TACTrLabel.DoDrawText(var Rect: TRect; Flags: Word);
var
  Text: string;
begin
  Text := GetLabelText;
  Canvas.Font := Font;
  if not Enabled then Canvas.Font.Color := clGrayText;
  DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
end;

(******************************************************************************
 * Disegna_Fondo                                                              *
 ******************************************************************************)
Procedure TACTrLabel.Disegna_Fondo;
Begin
  if not Transparent then
  begin
    ACProc_Sfumatura1(Color_Start,Color_End,Canvas,ClientRect,0);
  End;
end;
(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
Procedure TACTrLabel.Paint;
Var rec : TRect;
const
  Alignments: array[TAlignment] of Word = (DT_LEFT, DT_RIGHT, DT_CENTER);
  WordWraps: array[Boolean] of Word = (0, DT_WORDBREAK);

Begin
  Disegna_Fondo;
  With Canvas Do
  Begin
    Brush.Style := bsClear;
    Rec := ClientRect;
    DoDrawText(rec, DT_EXPANDTABS or WordWraps[WordWrap] or
      Alignments[Alignment]);
  end;

End;
end.
