(******************************************************************************
 * ACTransparentPanel                                                         *
 ******************************************************************************)
unit ACTransparentPanel;

(******************************************************************************
 * ACTransparentPanel                                                         *
 ******************************************************************************)
 interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACTransparentPanel = class(TCustomPanel)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
//    Constructor Create(AOwner: TComponent); Override;
    Procedure Paint; Override;
    Constructor Create(AOwner: TComponent);Override;

  published
    { Published declarations }
//    Property Color;
    Property Visible;
  end;



(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Create                                                                    *
 ******************************************************************************)
Constructor TACTransparentPanel.Create(AOwner: TComponent);
Begin
  Inherited;
  BevelInner := bvNone;
  BevelOuter := bvNone;
  BorderStyle := bsNone;
  Parentcolor := True;
end;
(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
Procedure TACTransparentPanel.Paint;
var
  Rgn1, Rgn2, Rgn3: THandle;
  Margin, X, Y: Integer;
  c1          : Integer;
begin
  Inherited;
  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('TAcTransparentPanel: Paint (ingresso)');
        ac_debug_add_text('                     Nome componente: '+Self.Name);
    end;
  {$endif}


  if (csDesigning in ComponentState) then
  Begin
    Canvas.rectangle(0,0,width,height);
    Canvas.textout(0,0,name);
    exit;
  end;
//  exit;
  Margin := (Width - ClientWidth) div 2;
  Rgn1 := CreateRectRgn(0, 0, Width, Height);
  X := Margin;
  Y := Height - ClientHeight - Margin;
  Rgn2 := CreateRectRgn(X, Y, X + ClientWidth, Y + ClientHeight);
  CombineRgn(Rgn1, Rgn1, Rgn2, RGN_DIFF);


  {$ifdef AC_DEBUG_MODE}
    if  not (csDesigning in ComponentState) then
    begin
        ac_debug_add_text('                     Rgn1: '+IntToStr(Rgn1));
        ac_debug_add_text('                     Rgn2: '+IntToStr(Rgn2));
        ac_debug_add_text('                     x: '+IntToStr(x));
        ac_debug_add_text('                     y: '+IntToStr(y));
    end;
  {$endif}



  if(ControlCount>0) Then
  begin
    For c1 := 0 to ControlCount - 1 Do
    Begin
      if (Controls[c1].Visible) then
      Begin
        Rgn3 := CreateRectRgn(Controls[c1].Left,
                              Controls[c1].Top,
                              Controls[c1].Left+Controls[c1].Width-1,
                              Controls[c1].Top+Controls[c1].Height);
        CombineRgn(Rgn1, Rgn1, Rgn3, RGN_OR);
      End;
    End;
  end;
  SetWindowRgn(Handle, Rgn1, True);
end;


end.
