(******************************************************************************
 * Ac Clock                                                                   *
 *                                                                            *
 * Domenica 10 ottobre 2004                                                   *
 * -------------------------------------------------------------------------- *
 * Inizio prima versione                                                      *
 ******************************************************************************)
unit AC_Clock;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
interface

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
type
  TACCustomClock = class(TCustomControl)
  private
    { Private declarations }
//    Area_Disegno : TLabel;
    F_Hour_Style : TPen;
    F_Min_Style : TPen;
    F_Sec_Style : TPen;
  protected
    { Protected declarations }
    Ore_Precedente,
    Minuti_Precedente,
    Secondi_Precedente,
    Millesimi_Precedente : Integer;
    Procedure Rinfresca(Ore,Minuti,Secondi,Millesimi:Integer);
    Procedure disegna_ore(Cnv:TCanvas;ore,minuti,secondi,Millesimi:integer;c1,c2,c3:Integer;w1,w2,w3:Integer;l1,l2,l3,l4:Integer);
    Procedure Disegna_Lancetta(Cnv:TCanvas;Valore,Fondo_Scala,Colore,Spessore,Lunghezza:Integer);
    function  Tempo2Angolo(ore,minuti,secondi,Millesimi,Tipo:integer):Real;
    Procedure Cambia_colore(Sender:Tobject);
    Property Style_Hour : TPen Read F_Hour_Style Write F_Hour_Style;
    Property Style_Min : TPen Read F_Min_Style Write F_Min_Style;
    Property Style_Sec : TPen Read F_Sec_Style Write F_Sec_Style;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    { Published declarations }
  end;

  TACClock = class(TACCustomClock)
  private
    { Private declarations }
//    Area_Disegno : TLabel;
    Tempo : TTimer;
  protected
    { Protected declarations }
    procedure go(Sender:Tobject);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor destroy; override;
    procedure paint;override;
  published
    { Published declarations }
    Property Style_Hour;
    Property Style_Min;
    Property Style_Sec;

  end;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
implementation

CONST NUMERO_ORE=12;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
constructor TACCustomClock.Create(AOwner: TComponent);
Begin
  Inherited;
  F_Hour_Style := TPen.Create;
  F_Min_Style := TPen.Create;
  F_Sec_Style := TPen.Create;
  F_Hour_Style.onChange  := Cambia_colore;
  F_Min_Style.onChange   := Cambia_colore;
  F_Sec_Style.onChange   := Cambia_colore;

  Style_Hour.Color := clBlue;
  Style_Hour.Width  := 3;

  Style_Min.Color := clRed;
  Style_Min.Width  := 2;

  Style_Sec.Color := clGreen;
  Style_Sec.Width  := 1;

  Width := 100;
  Height := 100;
  Ore_Precedente    := -1;
  Minuti_Precedente := -1;
  Secondi_Precedente := -1;
  Millesimi_Precedente := -1;
End;
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
Procedure TACCustomClock.Cambia_colore(Sender:Tobject);
Begin
  Invalidate;
End;
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
destructor TACCustomClock.Destroy;
begin
  F_Hour_Style.Free;
  F_Min_Style.Free;
  F_Sec_Style.Free;
  inherited;

end;


(******************************************************************************
 * Disegna lancetta                                                           *
 ******************************************************************************)
 Procedure TACCustomClock.Disegna_Lancetta(Cnv:TCanvas;Valore,Fondo_Scala,Colore,Spessore,Lunghezza:Integer);
 Var Delta_X, Delta_Y : Integer;
    Angolo           : Real;
    Dimensione       : Integer; // Indica la dimensione minima tra la larghezza
 Begin
  Angolo := 360/Fondo_Scala*Valore; // La proporzione 24 : 360 = Ore : x
  Angolo := (Angolo / 180 * pi); // Converto l'angolo in radianti
  Cnv.MoveTo(Width div 2, Height div 2);
  Delta_x := Round(Sin(Angolo)*Lunghezza);
  Delta_y := Round(Cos(Angolo)*Lunghezza);
  Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);

 End;

(******************************************************************************
 * Tempo2Angolo                                                               *
 *                                                                            *
 * Dato un orario (ore, minuti, secondi), restitisce l'angolo che avrebbe     *
 * la lancetta                                                                *
 *                                                                            *
 * Nome     Descrizione                                                       *
 * -------- ----------------------------------------------------------------- *
 * ore      Orario                                                            *
 * minuti   Orario                                                            *
 * secondi  Orario                                                            *
 * Tipo     1: Considera ore, minuti, secondi, millesimi                      *
 *          2: Considera minuti, secondi, millesimi                           *
 *          3: Considera secondi, millesimi                                   *
 *                                                                            *
 *                                                                            *
 * Tipo 1:                                                                    *
 *                                                                            *
 *    Tempo_Totale : 360 = Tempo_Corrente : Angolo                            *
 *                                                                            *
 *    Tempo Totale = 24 Ore = 86400000 Millesimi di Secondi                   *
 *                                                                            *
 *    8640000 : 360 = Tempo_Corrente : Angolo                                 *
 *                                                                            *
 *    Angolo = 360/86400 * Tempo_Corremte                                     *
 *                                                                            *
 *    Tempo_Corrente = (Secondi + Minuti * 60 + Ore * 3600) *100              *
 *                                                                            *
 *    Se l'orologio mostra solo 12 ore il valore del tempo totale             *
 *    risulta 8640000/2                                                       *
 *                                                                            *
 *                                                                            *
 * Tipo 2                                                                     *
 *    Valori espressi per i minuti                                            *
 *                                                                            *
 *    Tempo_Totale : 360 = Tempo_Corrente : Angolo                            *
 *                                                                            *
 *    Tempo Totale = 60 minuti = 3600 Secondi = 3600000 Millesimi di secondo  *
 *                                                                            *
 *    360000 : 360 = Tempo_Corrente : Angolo                                  *
 *                                                                            *
 *    Angolo = 360/360000 * Tempo_Corrente                                    *
 *                                                                            *
 *    Tempo_Corrente = Secondi + Minuti * 60                                  *
 *                                                                            *
 *                                                                            *
 * Tipo 3                                                                     *
 *                                                                            *
 *                                                                             *
 ******************************************************************************)

function  TACCustomClock.Tempo2Angolo(ore,minuti,secondi,Millesimi,Tipo:integer):Real;
Var Angolo : real;
begin
  Angolo := 0;
  if (Tipo=1) then
  begin
    Angolo := 360/(86400000*NUMERO_ORE/24)*(Millesimi+Secondi*1000+Minuti*60*1000+Ore*3600*1000);
    Angolo := (Angolo / 180 * pi); // Converto l'angolo in radianti
  end;
  if (Tipo=2) then
  begin
    Angolo := (360/3600000)*(Millesimi+Minuti*60*1000+Secondi*1000); // La proporzione 60 : 360 = Ore : x
    Angolo := (Angolo / 180 * pi); // Converto l'angolo in radianti
  end;
  if (Tipo=3) then
  begin
    Angolo := 360/60000*(Secondi*1000+Millesimi); // La proporzione 60 : 360 = Ore : x
    Angolo := (Angolo / 180 * pi); // Converto l'angolo in radianti
  end;


  Tempo2Angolo := Angolo;

end;
(******************************************************************************
 * Disegna lancetta                                                           *
 *                                                                            *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * ore           numero dell'ora                                              *
 * minuti        numero di minuti                                             *
 * secondi       numero dei secondi                                           *
 * c1            spessore lancetta ore                                        *
 * c2            spessore lancetta minuti                                     *
 * c3            spessore lancetta secondi                                    *
 * w1            colore lancetta ore                                          *
 * w2            colore lancetta minuti                                       *
 * w3            colore lancetta secondi                                      *
 * l1            Lunghezza lacetta ore                                        *
 * l2            Lunghezza lacetta minuti                                     *
 * l3            Lunghezza lacetta secondi                                    *
 * l4            Lunghezza retro lancetta                                     *
 ******************************************************************************)
Procedure TACCustomClock.disegna_ore(Cnv:TCanvas;ore,minuti,secondi,Millesimi:integer;c1,c2,c3:Integer;w1,w2,w3:Integer;l1,l2,l3,l4:Integer);
Var Delta_X, Delta_Y : Integer;
    Angolo1, Angolo2           : Real;
    Dimensione       : Integer; // Indica la dimensione minima tra la larghezza
                                // e l'altezza, e' usata per disegnare l'orologio
begin

//********** Lancetta Ore **********
  Angolo1 := Tempo2Angolo(ore,minuti,secondi,Millesimi,1);
  Angolo2 := Tempo2Angolo(ore_precedente,minuti_precedente,secondi_precedente,Millesimi_precedente,1);

  Cnv.Pen.Assign(Style_Hour);
  if (Ore_Precedente<>-1) and (angolo1<>angolo2) then
  begin
    Cnv.Pen.Style := psSolid;
    Cnv.Pen.Color := Color;
    Delta_x := Round(Sin(Angolo2)*L4);
    Delta_y := Round(Cos(Angolo2)*L4);
    Cnv.MoveTo(Width div 2-Delta_X, Height div 2+Delta_y);
    Delta_x := Round(Sin(Angolo2)*L1);
    Delta_y := Round(Cos(Angolo2)*L1);
    Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);
  end;

  Cnv.Pen.Assign(Style_Hour);
  Delta_x := Round(Sin(Angolo2)*L4);
  Delta_y := Round(Cos(Angolo2)*L4);
  Cnv.MoveTo(Width div 2-Delta_X, Height div 2+Delta_y);
  Delta_x := Round(Sin(Angolo1)*L1);
  Delta_y := Round(Cos(Angolo1)*L1);
  Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);

//********** Lancetta Minuti **********
  Angolo1 := Tempo2Angolo(ore,minuti,secondi,Millesimi,2);
  Angolo2 := Tempo2Angolo(ore_precedente,minuti_precedente,secondi_precedente,Millesimi_precedente,2);

  Cnv.Pen.Assign(Style_Min);
  if (minuti_Precedente<>-1) and (angolo1<>angolo2) then
  begin
    Cnv.Pen.Style := psSolid;
    Cnv.Pen.Color := Color;
    Delta_x := Round(Sin(Angolo2)*L4);
    Delta_y := Round(Cos(Angolo2)*L4);
    Cnv.MoveTo(Width div 2-Delta_X, Height div 2+Delta_y);
    Delta_x := Round(Sin(Angolo2)*L2);
    Delta_y := Round(Cos(Angolo2)*L2);
    Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);
  end;

  Cnv.Pen.Assign(Style_Min);
  Delta_x := Round(Sin(Angolo2)*L4);
  Delta_y := Round(Cos(Angolo2)*L4);
  Cnv.MoveTo(Width div 2-Delta_X, Height div 2+Delta_y);
  Delta_x := Round(Sin(Angolo1)*L2);
  Delta_y := Round(Cos(Angolo1)*L2);
  Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);

//********** Lancetta Secondi **********
  Angolo1 := Tempo2Angolo(ore,minuti,secondi,Millesimi,3);
  Angolo2 := Tempo2Angolo(ore_precedente,minuti_precedente,secondi_precedente,Millesimi_precedente,3);
  Cnv.Pen.Assign(Style_Sec);
  if (secondi_Precedente<>-1) and (angolo1<>angolo2) then
  begin
    Cnv.Pen.Style := psSolid;
    Cnv.Pen.Color := Color;
    Delta_x := Round(Sin(Angolo2)*L4);
    Delta_y := Round(Cos(Angolo2)*L4);
    Cnv.MoveTo(Width div 2-Delta_X, Height div 2+Delta_y);
    Delta_x := Round(Sin(Angolo2)*L3);
    Delta_y := Round(Cos(Angolo2)*L3);
    Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);
  end;
  Cnv.Pen.Assign(Style_Sec);

  Delta_x := Round(Sin(Angolo2)*L4);
  Delta_y := Round(Cos(Angolo2)*L4);
  Cnv.MoveTo(Width div 2-Delta_X, Height div 2+Delta_y);

  Delta_x := Round(Sin(Angolo1)*L3);
  Delta_y := Round(Cos(Angolo1)*L3);
  Cnv.LineTo(Width div 2+Delta_X, Height div 2-Delta_y);

end;
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
Procedure TACCustomClock.Rinfresca(Ore,Minuti,Secondi,Millesimi:Integer);
Var
    Angolo           : Real;
    c1               : Integer;
    Dimensione       : Integer; // Indica la dimensione minima tra la larghezza
                                // e l'altezza, e' usata per disegnare l'orologio
    Dimensione_L_Ore,           // Dimensione lancetta ore
    Dimensione_L_Min,           // Dimensione lancetta minuti
    Dimensione_L_Sec,
    Dimensione_R : Integer; // Dimensione lancetta secondi
    Start_Tacca,
    End_Tacca,
    Colore_Tacca,
    Spessore_Tacca   : Integer;
Begin
  if (Height < Width ) then Dimensione := Height div 2
  else Dimensione := Width div 2;


  Dimensione_L_Ore := Round(Dimensione * 40 / 100);
  Dimensione_L_Min := Round(Dimensione * 60 / 100);
  Dimensione_L_Sec := Round(Dimensione * 70 / 100);
  Dimensione_R     := Round(Dimensione * 20 / 100);
  Start_Tacca      := Round(Dimensione * 75 / 100);
  End_Tacca        := Round(Dimensione * 80 / 100);
  Colore_Tacca     := clBlue;
  Spessore_Tacca   := 1;

//********** Secoondi **********
  if (Secondi<0) then
  begin
    Secondi := 59;
    Minuti := Minuti-1;
  end;
  if (Secondi>59) then
  begin
    Secondi := 0;
    Minuti := Minuti+1;
  end;

//********** Minuti **********
  if (Minuti<0) then
  begin
    Minuti := 59;
    Ore := Ore-1;
  end;
  if (Minuti>59) then
  begin
    Minuti := 0;
    Ore := Ore+1;
  end;

//********** Ore **********
  if (Ore<0) then Ore := 23;
  if (Ore>23) then Ore := 0;


//********** Disegna l'orologio **********
  //LockWindowUpdate(handle);
 Canvas.Pen.Color := Colore_Tacca;
 Canvas.Pen.Width := Spessore_Tacca;
 Canvas.Font.Name := 'Arial';
 Canvas.Brush.Style := bsClear;

 for c1 := 1 to NUMERO_ORE do
 begin
   Angolo := Tempo2Angolo(c1,0,0,0,1);
   Canvas.TextOut(Width div 2+Round(End_Tacca*Sin(Angolo)),
                  Height div 2-Round(End_Tacca*Cos(Angolo))-Canvas.TextHeight(IntToStr(c1)) div 2,
                  IntToStr(c1))


 end;

 for c1 := 0 to 59 do
 begin
   Angolo :=  Tempo2Angolo(0,c1,0,0,2);
   Canvas.MoveTo(Width div 2+Round(Start_Tacca*Cos(Angolo)),
                 Height div 2-Round(Start_Tacca*Sin(Angolo)));

   Canvas.LineTo(Width div 2+Round(End_Tacca*Cos(Angolo)),
                 Height div 2-Round(End_Tacca*Sin(Angolo)));

 end;

//********** Scrive le nuove lancette **********
 disegna_ore(Canvas,ore, minuti, secondi, Millesimi,
              clBlue, clGreen, clred,
              3,2,1,
              Dimensione_L_Ore, Dimensione_L_Min, Dimensione_L_Sec, Dimensione_R);
 Ore_Precedente        := Ore;
 Minuti_Precedente     := Minuti;
 Secondi_Precedente    := Secondi;
 Millesimi_Precedente  := Millesimi;


End;


(******************************************************************************
 *                                                                            *
 ******************************************************************************)
procedure TACClock.paint;
var a,b,c,d,aa:word;
begin
 inherited;
 DecodeTime(now,c,b,a,aa);
 if (c=24) then c := 0;
 Rinfresca(c,b,a,aa);
end;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
constructor TACClock.Create(AOwner: TComponent);
begin
  Inherited;
  Tempo := TTimer.Create(self);
  Tempo.Interval := 20;
  Tempo.Enabled := True;
  Tempo.OnTimer := Go;
end;
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
destructor TACClock.destroy;
begin
  Tempo.Free;
  Inherited;
end;
(******************************************************************************
 *                                                                            *
 ******************************************************************************)
procedure TACClock.go(Sender:Tobject);
var a,b,c,d,aa:word;
begin
 Invalidate;
end;



end.
