(******************************************************************************
 * ACColorCombo                                                               *
 ******************************************************************************)
unit ACColorCombo;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TACColorCombo = class(TCustomComboBox)
  private
    { Private declarations }
    FColori : TStringList;
  protected
    { Protected declarations }
    constructor Create(AOwner: TComponent); Override;
    destructor Destroy; Override;
    Procedure Set_Colori(f:TStringList);
    Procedure Scrive_Lista_Colori;
    Procedure Aggiunge_Linea(num:Integer;Default:String);
    procedure CreateWnd; Override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); Override;
    Procedure Set_ItemIndex(x:Integer);
    Function  Get_ItemIndex :Integer;
  public
    { Public declarations }
  published
    Property NomiColori : TStringList Read Fcolori Write Set_Colori;
    Property IndiceColore : Integer Read Get_ItemIndex Write Set_ItemIndex;
    { Published declarations }
  end;


implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses AcConst;

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACColorCombo.Create(AOwner: TComponent);
Begin
  Inherited;
  FColori := TStringList.Create;
  Style := csOwnerDrawFixed;
End;

(******************************************************************************
 * CreateWnd                                                                  *
 ******************************************************************************)
procedure TACColorCombo.CreateWnd;
begin
  inherited CreateWnd;
  Scrive_Lista_Colori;
  ItemIndex := 0;
end;

(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TACColorCombo.Destroy;
Begin
  Fcolori.Free;
  Inherited;
End;

(******************************************************************************
 * Set_Colori                                                                 *
 ******************************************************************************)
Procedure TACColorCombo.Set_Colori(f:TStringList);
Begin
  FColori.Assign(f);
End;
(*  clScrollBar = COLOR_SCROLLBAR or $80000000;
  clBackground = COLOR_BACKGROUND or $80000000;
  clActiveCaption = COLOR_ACTIVECAPTION or $80000000;
  clInactiveCaption = COLOR_INACTIVECAPTION or $80000000;
  clMenu = COLOR_MENU or $80000000;
  clWindow = COLOR_WINDOW or $80000000;
  clWindowFrame = COLOR_WINDOWFRAME or $80000000;
  clMenuText = COLOR_MENUTEXT or $80000000;
  clWindowText = COLOR_WINDOWTEXT or $80000000;
  clCaptionText = COLOR_CAPTIONTEXT or $80000000;
  clActiveBorder = COLOR_ACTIVEBORDER or $80000000;
  clInactiveBorder = COLOR_INACTIVEBORDER or $80000000;
  clAppWorkSpace = COLOR_APPWORKSPACE or $80000000;
  clHighlight = COLOR_HIGHLIGHT or $80000000;
  clHighlightText = COLOR_HIGHLIGHTTEXT or $80000000;
  clBtnFace = COLOR_BTNFACE or $80000000;
  clBtnShadow = COLOR_BTNSHADOW or $80000000;
  clGrayText = COLOR_GRAYTEXT or $80000000;
  clBtnText = COLOR_BTNTEXT or $80000000;
  clInactiveCaptionText = COLOR_INACTIVECAPTIONTEXT or $80000000;
  clBtnHighlight = COLOR_BTNHIGHLIGHT or $80000000;
  cl3DDkShadow = COLOR_3DDKSHADOW or $80000000;
  cl3DLight = COLOR_3DLIGHT or $80000000;
  clInfoText = COLOR_INFOTEXT or $80000000;
  clInfoBk = COLOR_INFOBK or $80000000;

    *)


(******************************************************************************
 * ACColorCombo                                                               *
 ******************************************************************************)
Procedure TACColorCombo.Aggiunge_Linea(num:Integer;Default:String);
Begin
  if (NomiColori.Count>num) then Items.Add(NomiColori[num])
  Else Items.Add(Default);
End;
(******************************************************************************
 * ACColorCombo                                                               *
 ******************************************************************************)
Procedure TACColorCombo.Scrive_Lista_Colori;
Begin
  Items.BeginUpdate;
  Items.Clear;

  Aggiunge_Linea(00,'Nero');
  Aggiunge_Linea(01,'Marrone');
  Aggiunge_Linea(02,'Verde');
  Aggiunge_Linea(03,'Oliva');
  Aggiunge_Linea(04,'Blu scuro');
  Aggiunge_Linea(05,'Porpora');
  Aggiunge_Linea(06,'Teal');
  Aggiunge_Linea(07,'Grigio chiaro');
//  Aggiunge_Linea(08,'Argento');
  Aggiunge_Linea(09,'Rosso');
  Aggiunge_Linea(10,'Verde chiaro');
  Aggiunge_Linea(11,'Giallo');
  Aggiunge_Linea(12,'Blu chiaro');
  Aggiunge_Linea(13,'Fucsia');
  Aggiunge_Linea(14,'Acqua');
//  Aggiunge_Linea(15,'Grigio chiaro');
  Aggiunge_Linea(15,'Grigio scuro');
  Aggiunge_Linea(16,'Bianco');

  Items.EndUpdate;

End;

(******************************************************************************
 * DrawItem                                                                   *
 ******************************************************************************)
procedure TACColorCombo.DrawItem(Index: Integer; Rect: TRect;
  State: TOwnerDrawState);
const
  ColorWidth = 22;
var
  ARect: TRect;
  Text: array[0..255] of Char;
begin
  ARect := Rect;
  Inc(ARect.Top, 2);
  Inc(ARect.Left, 2);
  Dec(ARect.Bottom, 2);
  ARect.Right := ARect.Left + ColorWidth;

  with Canvas do
  begin
    Pen.Color := clBlack;
//********* Svuota la riga *********
    Brush.Color := Color;
    FillRect(Rect);
//********* Disegna il rettangolo *********
    Brush.Color := ACValoriColori[Index];
    FillRect(ARect);
    Canvas.Pen.Color := clBlack;
    Rectangle(ARect.Left,ARect.Top,ARect.Right,ARect.Bottom);

//********* Scrive il colore *********
    Brush.Color := Color;
    StrPCopy(Text, Items[Index]);
    Rect.Left := Rect.Left + ColorWidth + 6;
    Font.Color := clBlack;
    TextRect(Rect,Rect.Left,Rect.Top,Text);
//    DrawText(Canvas.Handle, Text, StrLen(Text), Rect, DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
  End;
end;

(******************************************************************************
 * Set_ItemIndex                                                              *
 ******************************************************************************)
Procedure TACColorCombo.Set_ItemIndex(x:Integer);
Begin
  ItemIndex := x;
End;

(******************************************************************************
 * Get_ItemIndex                                                              *
 ******************************************************************************)
Function  TACColorCombo.Get_ItemIndex :Integer;
Begin
  Get_ItemIndex := ItemIndex;
End;
end.
