(******************************************************************************
 * ACDissolveBmp                                                              *
 ******************************************************************************)
unit ACDissolveBmp;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ACDateTime;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  Proc_Larg_Alt = Procedure (Sender:Tobject;Var Dx,Dw:Integer) of object;
  TEffect = (efLine,efGrow,efShade);
  Parray = array[0..0] of byte;
  TACDissolveBmp = class(TImage)
  private
    { Private declarations }
    acDT             : TACDateTime;
    Quale_ef         : TEffect;
    FName            : String;
    T1               : TTimer;
    FTempo           : Integer;
    N_Linee          : Integer;
    Intervallo       : Integer;
    Bmp              : TBitMap;
    C_Cnv            : TBitMap;
    Delta,
    Contatore        : Integer;

    fFine            : TNotifyEvent;
    fbefore          : Proc_Larg_Alt;
    Por,
    Pvr              : Integer;

    Sopra,                         // Questi 4 parametri indicano l'area di
    Sotto,                         // destinazione dell'immagine, vengono
    Sinistra,                      // calcolati in base all'immagine.
    Destra           : Integer;    // "Sotto" e "Destra" poi sono confermati  dall'utente

    Larghezza_Bmp,                 // Contiene la larghezza dell'immagine da inserire
    Altezza_Bmp      : Integer;    // Contiene l'altezza dell'immagine da inserire

    Por_Bmp          : Integer;
    Sto_dissolvendo  : Boolean;
    Altezza          : Integer;
    abp1,
    abp2,
    abp3             : ^PArray;
  protected
    { Protected declarations }
    Procedure Set_Tempo(X:Integer);
    Procedure Dissolve_1(Cnv:TCanvas);
    Procedure Dissolve_2(Cnv:TCanvas);
    Procedure Dissolve_3(Cnv:TCAnvas);
    Procedure Calcola_Margini;

  public
    { Public declarations }
    Time_To_Load_Bmp : Integer;
    constructor Create(AOwner: TComponent); override;

    destructor Destroy; override;
    Procedure Start;
    procedure TimTimer(Sender: TObject);
    Procedure ShowImage;
    Procedure Image_Load;
    Procedure Image_Dissolve;
  published
    { Published declarations }
    property ImageToDissolve  : String        Read FName    Write FName;
    Property TimeToDissolve   : Integer       Read FTempo   Write Set_Tempo;
    Property OnTerminate      : TNotifyEvent  Read fFine    Write fFine;
    Property OnBeforeDissolve : Proc_Larg_Alt Read fbefore  Write fbefore;
    Property Effect           : TEffect       Read Quale_Ef Write Quale_ef;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TACDissolveBmp.Create(AOwner: TComponent);
Begin
  Inherited;
  acDT             := TACDateTime.Create(Self);
  Quale_Ef         := efLine;
  Sto_dissolvendo  := False;
  OnTerminate      := Nil;
  OnBeforeDissolve := Nil;
  T1               := TTimer.Create(self);
  T1.Enabled       := False;
  T1.OnTimer       := TimTimer;
  Intervallo       := 100;
  TimeToDissolve   := 10;
//  N_Linee            := ClientHeight div (TimeToDissolve div Intervallo);
  N_Linee          := 50;

  Bmp              := TBitMap.Create;
  C_Cnv            := TBitMap.Create;
End;

(******************************************************************************
 * destructor                                                                 *
 ******************************************************************************)
destructor TACDissolveBmp.Destroy;
Begin
  acDT.free;
  C_Cnv.Free;
  T1.Free;
  Bmp.Free;
  Inherited;
End;

(******************************************************************************
 * Calcola_Margini                                                            *
 ******************************************************************************)
Procedure TACDissolveBmp.Calcola_Margini;
Var c1,t1,t2 : Integer;
Begin
 Sinistra          := 0;
 Destra            := Bmp.Width;
 Sopra             := 0;
 Sotto             := Bmp.Height;
 Larghezza_Bmp     := Destra;
 Altezza_Bmp       := Sotto;
 if (Assigned(OnBeforeDissolve)) Then OnBeforeDissolve(Self,Destra,Sotto);


 if (Sotto div 2<N_Linee) Then N_Linee := Sotto div 2;
 Delta             := (ClientHeight Div N_Linee)+1;
 if (Delta=0) Then Delta := 1;
 Intervallo        := TimeToDissolve div Delta;
 if (Intervallo=0) Then Intervallo := 1;

//******** Dissolvenza ********
  t1 := acDT.Msec + 1000 * (acDT.Second + 60 * (acDT.Minute + 60 * acDT.Hour));
  For c1 := 1 to 10 do
  Begin
    if (Quale_Ef=efLine) Then Dissolve_1(C_Cnv.Canvas)
    Else if (Quale_Ef=efGrow) Then Dissolve_2(C_Cnv.Canvas)
//    Else Dissolve_3(C_Cnv.Canvas);
  End;
  t2 := acDT.Msec + 1000 * (acDT.Second + 60 * (acDT.Minute + 60 * acDT.Hour));
  if (t2<t1) then t2 := t1+1;
  Intervallo := Intervallo - ((t2-t1) div 10);
  if (Intervallo<0) then Intervallo := 1;
//********* Margini *********
 Por               := (ClientWidth-Destra) div 2;
 Pvr               := (ClientHeight-Sotto) div 2;
 if (Larghezza_Bmp>Destra) Then
 Begin
   Por_Bmp           := (Larghezza_Bmp-Destra) div 2;
 End
 Else Por_Bmp := 0;

End;
(******************************************************************************
 * Start                                                                      *
 ******************************************************************************)
Procedure TACDissolveBmp.Start;
Begin
 Image_Load;
 Image_Dissolve;
End;

(******************************************************************************
 * Set_Tempo                                                                  *
 ******************************************************************************)
Procedure TACDissolveBmp.Set_Tempo(X:Integer);
Begin
  FTempo := x;
End;

(******************************************************************************
 * Load_Image                                                                 *
 ******************************************************************************)
Procedure TACDissolveBmp.Image_Load;
Var c1,c2 : Integer;
Begin
 c1 := acDT.Msec + 1000 * (acDT.Second + 60 * (acDT.Minute + 60 * acDT.Hour));
 Bmp.LoadFromFile(ImageToDissolve);
 c2 := acDT.Msec + 1000 * (acDT.Second + 60 * (acDT.Minute + 60 * acDT.Hour));
 if (c2>c1) then c2 := c1;
 Time_To_Load_Bmp := c2-c1;

End;

(******************************************************************************
 * Image_Dissolve                                                             *
 ******************************************************************************)
Procedure TACDissolveBmp.Image_Dissolve;
Begin
  if (Effect=efShade) then
  Begin
    abp1 := AllocMem(Picture.BitMap.Width*Picture.BitMap.height*3);
    abp2 := AllocMem(Picture.BitMap.Width*Picture.BitMap.height*3);
    abp3 := AllocMem(Picture.BitMap.Width*Picture.BitMap.height*3);
  End;
  Calcola_Margini;
  Altezza           := Height;
  Contatore         := 0;
  t1.Interval       := Intervallo;
  T1.Enabled        := True;
End;

(******************************************************************************
 * Dissolve_1                                                                 *
 ******************************************************************************)
Procedure TACDissolveBmp.Dissolve_1(Cnv:TCAnvas);
Var
    C1 : Integer;
Begin

  LockWindowUpdate(C_Cnv.Handle);
  For c1 := 0 to n_Linee - 1 do
  Begin
    Cnv.MoveTo(0,c1*Delta+Contatore);
    Cnv.LineTo(Width,c1*Delta+Contatore);
    if (c1*Delta+Contatore>=pvr) and (c1*Delta+Contatore<Altezza-pvr) then
    Begin
      Cnv.copyrect(Rect(por+Sinistra,      // X1
                        c1*Delta+Contatore,           // Y1
                        por+Destra,        // X2
                        c1*Delta+Contatore+1),        // Y2
                      Bmp.Canvas,
                   Rect(0+Por_Bmp,
                        c1*Delta+Contatore-pvr,
                        Destra+Por_Bmp,
                        c1*Delta+Contatore+1-pvr))
    End;
  End;
  LockWindowUpdate(0);
End;
(******************************************************************************
 * Dissolve_2                                                                 *
 ******************************************************************************)
Procedure TACDissolveBmp.Dissolve_2(Cnv:TCAnvas);
Var
    l1,
    h1,
    cx,
    cy,
    dl : Integer;
Begin
    if (Sto_dissolvendo) Then exit;
    Sto_dissolvendo    := True;

    if (Contatore<>0) then
      dl := Delta div contatore
    Else dl := Delta+1;

    LockWindowUpdate(C_Cnv.Handle);
    if (dl<=1) then
    Begin

      Cnv.FillRect(ClientRect);
      dl := 1;
    End;

    cx := Destra div 2;
    cy := Sotto div 2;
    l1 := cx div dl;
//    if (l1>Destra div 2) then l1 := Destra div 2;
    h1 := cy div dl;
    Cnv.StretchDraw(Rect(por+cx-l1,
                         pvr+cy-h1,
                         por+cx+l1,
                         pvr+cy+h1),
                         Bmp);
    LockWindowUpdate(0);
    Sto_dissolvendo := False;

End;

(******************************************************************************
 * Dissolve_3                                                                 *
 ******************************************************************************)
Procedure TACDissolveBmp.Dissolve_3(Cnv:TCAnvas);
Var
  c1    : Integer;
Begin
    LockWindowUpdate(Picture.Bitmap.Handle);
    if (Sto_dissolvendo) Then exit;
    Sto_dissolvendo    := True;
    if (Contatore=0) then
    Begin
      GetBitMapBits(Picture.Bitmap.Handle,Picture.BitMap.Width*Picture.BitMap.height*3,abp1);
      GetBitMapBits(Bmp.Handle,Picture.BitMap.Width*Picture.BitMap.height*3,abp2);
    End;
    for c1 := 0 to Picture.BitMap.Width*Picture.BitMap.height*3-1 do
    Begin
      abp3[c1] := (abp1[c1]*(Delta-Contatore) + abp2[c1]*Contatore) div Delta;
    End;

    SetBitMapBits(Picture.Bitmap.Handle,Picture.BitMap.Width*Picture.BitMap.height*3,abp3);
    LockWindowUpdate(0);
    Paint;
    Sto_dissolvendo := False;

End;


(******************************************************************************
 * TimTimer                                                                   *
 ******************************************************************************)
procedure TACDissolveBmp.TimTimer(Sender: TObject);
begin
  T1.Enabled         := False;
  Canvas.Brush.Color := clBlack;

//******** Dissolvenza ********
  if (Quale_Ef=efLine) Then Dissolve_1(Canvas)
  Else if (Quale_Ef=efGrow) then Dissolve_2(Canvas)
  Else Dissolve_3(Canvas);
//******** Fine dissolvenza ********
  if (Contatore>=Delta) Then
  Begin
    T1.Enabled := False;
    Contatore := 0;
    if (Assigned(OnTerminate)) Then OnTerminate(Self);
    if (Effect=efShade) then
    Begin
      FreeMem(abp1);
      FreeMem(abp2);
      FreeMem(abp3);
    End;

    exit;
  End;
  Inc(Contatore);
//  Application.processmessages;
  T1.Enabled := True;
End;

(******************************************************************************
 * ShowImage                                                                  *
 ******************************************************************************)
Procedure TACDissolveBmp.ShowImage;
Begin
 Image_Load;
 Calcola_Margini;

 canvas.copyrect(Rect(por+Sinistra,      // X1
                      Pvr,               // Y1
                      por+Destra,        // X2
                      Pvr+Sotto),        // Y2
                    Bmp.Canvas,
                    Rect(por_bmp+0,
                         Sopra,
                         Larghezza_Bmp-por_bmp,
                         Sotto));
 if (Assigned(OnTerminate)) Then OnTerminate(Self);

End;

end.
