(******************************************************************************
 * AC Foglio                                                                  *
 ******************************************************************************)
unit AcFoglio;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, AcProcDeclare;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type

  TFoglio = class(TPersistent)
{********** Private declarations **********}
  private
    FWidth,
    FHeight : Integer;
    F_BackColor    : TColor;
{********** Protected declarations **********}
  protected
    F_On_Change : TAC_Proc_Foglio_Change;
    procedure Set_Color_1(c:TColor);
    procedure Set_FWidth(num:Integer);
    procedure Set_FHeight(num:Integer);

{********** Public declarations **********}
  public

{********** Published declarations **********}
  published
    property Width: Integer read FWidth write Set_FWidth default 200;
    property Height: Integer read FHeight write Set_FHeight default 200;
    property OnChange : TAC_Proc_Foglio_Change Read F_on_Change Write F_on_Change;
    property BackColor : TColor Read F_BackColor Write Set_Color_1;
  end;


  TACFoglio = class(TScrollBox)
  private
{********** Private declarations **********}
    F_Foglio : TFoglio;
    My_Foglio : TShape;

  protected
{********** Protected declarations **********}

    procedure Set_F_Foglio(F:TFoglio);
    procedure Change_Foglio(Sender: TObject;W,H:Integer);
  public
{********** Public declarations **********}
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure add(x,y:Integer;Comp:TComponent);
  published
{********** Published declarations **********}
    property Foglio : TFoglio Read F_Foglio Write Set_F_Foglio stored True;
  end;


(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************)
  Const
    Margine_Foglio = 10;
(******************************************************************************
 * Set_FWidth                                                                 *
 ******************************************************************************)
procedure  TFoglio.Set_FWidth(num:Integer);
Begin
 FWidth := Num;
 if(Assigned(OnChange)) then OnChange(Self,Width,Height);
End;

(******************************************************************************
 * Set_FHeight                                                                *
 ******************************************************************************)
procedure  TFoglio.Set_FHeight(num:Integer);
Begin
 FHeight := Num;
 if(Assigned(OnChange)) then OnChange(Self,Width,Height);
End;

(******************************************************************************
 * Set_Color_1                                                                *
 ******************************************************************************)
procedure  TFoglio.Set_Color_1(c:TColor);
Begin
  F_BackColor := c;
  if(Assigned(OnChange)) then OnChange(Self,Width,Height);
End;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACFoglio.Create(AOwner: TComponent);
begin
 inherited;
 Ctl3D                   := False;
 Color                   := clWindow;
 F_Foglio                := TFoglio.Create;//(Self);

 MY_Foglio               := TShape.Create(Self);
 My_Foglio.Parent        := Self;
 My_Foglio.Brush.Color   := clWindow;
 Foglio.OnChange         := Change_Foglio;
 Foglio.BackColor        := clWindow;
 Foglio.Width            := 2700;
 Foglio.Height           := 2100;
// HorzScrollBar.Tracking  := True;
// VertScrollBar.Tracking  := True;
end;

(******************************************************************************
 * AC Destroy                                                                 *
 ******************************************************************************)
destructor TACFoglio.Destroy;
begin
 F_Foglio.Free;
 MY_Foglio.Free;
 inherited;
end;


(******************************************************************************
 * Set_F_Foglio                                                               *
 ******************************************************************************)
procedure TACFoglio.Set_F_Foglio(F:TFoglio);
Begin
  F_Foglio.Assign(F);
  MY_Foglio.Width         := Foglio.Width;
  My_Foglio.Height        := Foglio.Height;
End;

(******************************************************************************
 * Change_Foglio                                                              *
 ******************************************************************************)
procedure TACFoglio.Change_Foglio(Sender: TObject;W,H:Integer);
Begin
 My_Foglio.Left          := Margine_Foglio;
 My_Foglio.Top           := Margine_Foglio;
 My_Foglio.Height        := H;
 My_Foglio.Width         := W;
 My_Foglio.Brush.Color   := Foglio.BackColor;
 My_Foglio.Pen.Width     := 2;
 VertScrollBar.Range     := H+Margine_Foglio*2;
 HorzScrollBar.Range     := W+Margine_Foglio*2;

End;

(******************************************************************************
 * Change_Foglio                                                              *
 ******************************************************************************)
procedure TACFoglio.add(x,y:Integer;Comp:TComponent);
Begin
end;
end.
