(******************************************************************************
 * AcLblTimer                                                                 *
 ******************************************************************************)
unit AcLblTimer;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, AcPanel;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TAcLblTimer = class(TAcPanel)
  private
    { Private declarations }
  protected
    { Protected declarations }
    T1          : TTimer;
    Solo_Tempo  : Boolean;
    procedure In_Tempo(Sender: TObject);
    Procedure Stampa_Ora;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); Override;
    procedure Paint; Override;
    destructor Destroy; Override;

  published
    { Published declarations }
    Property Font;
  end;

(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation


(******************************************************************************
 * Create                                                                     *
 ******************************************************************************)
constructor TAcLblTimer.Create(AOwner: TComponent);
begin
  Solo_Tempo := False;
  inherited Create(AOwner);
  if (ComponentState <> [csDesigning]) Then
  Begin
    T1 := TTimer.Create(self);
    T1.Interval := 1000;
    T1.OnTimer  := In_Tempo;
  End;
end;

(******************************************************************************
 * In_Tempo                                                                   *
 ******************************************************************************)
procedure TAcLblTimer.In_Tempo(Sender: TObject);
Begin
 Solo_Tempo := True;
 Repaint;
 Solo_Tempo := False;

//  Stampa_Ora;
End;

(******************************************************************************
 * Destructor                                                                 *
 ******************************************************************************)
destructor TAcLblTimer.Destroy;
Begin
  if (ComponentState <> [csDesigning]) Then
  Begin
    T1.Free;
  End;
  Inherited;
End;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TAcLblTimer.Paint;
Const Margine = 4;
begin
  if (Not Solo_Tempo) Then inherited Paint;
  Stampa_Ora;

end;

(******************************************************************************
 * Stampa_Ora                                                                 *
 ******************************************************************************)
Procedure TAcLblTimer.Stampa_Ora;
Const Margine = 4;
Var R   : TRect;
    Txt : String;
Begin
//  Paint;
  Canvas.Brush.Color := clBlack;
  R := Rect(Margine+1,Margine+1,Width-Margine-1,Height-Margine-1);
  Txt := DateTimeToStr(Now);

  Canvas.TextRect(R,
                 (Width  - Canvas.TextWidth(Txt)) Div 2,
                 (Height - Canvas.TextHeight(Txt)) Div 2,
                 Txt);

End;

end.
