(******************************************************************************
 * AcOperationString                                                          *
 ******************************************************************************)
unit AcOperationString;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
type
  TAcOperationString = class(TComponent)
  private
    { Private declarations }
    Str_Op1 : String;
    Str_Op2 : String;
  protected
    { Protected declarations }
    Function Somma(num1,num2:String):String;
    Function Sottrazione(num1,num2:String):String;
    function prestito_per_sottrazione(Var App1:String;indice:Integer):Boolean;
    Function Prepara_Stringhe(Var App1,App2 : String):Integer;
    function Maggiore(n1,n2:string):Integer;
    Procedure Set_Str_Op1(num:String);
    Procedure Set_Str_Op2(num:String);
    Function Toglie_Zero(Valore : String):String;
  public
    { Public declarations }
    function Add : String;
    function Sub : String;
    Function Multiply : String;
  published
    { Published declarations }
    property Valore1 : String Read Str_Op1 Write Set_Str_Op1;
    property Valore2 : String Read Str_Op2 Write Set_Str_Op2;

  end;


(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
Implementation

(******************************************************************************
 * Set_Str_Op1                                                                *
 ******************************************************************************)
Procedure TAcOperationString.Set_Str_Op1(num:String);
Var c1  : Integer;
    App : String;
    Vr  : boolean;
Begin
  App := '';
  Vr  := False;
  For c1 := 1 to Length(Num) Do
  Begin
    if (Num[c1]>='0')and(Num[c1]<='9')or(Num[c1]='.')  then
    Begin
      if (Num[c1]='.') Then
      Begin
        if  (Not Vr) Then Vr := True
        else Exit;
      End;
      App := App + Num[c1];
    End;
  End;
  Str_Op1 := App;
End;
(******************************************************************************
 * Set_Str_Op2                                                                *
 ******************************************************************************)
Procedure TAcOperationString.Set_Str_Op2(num:String);
Var c1  : Integer;
    App : String;
    Vr  : boolean;
Begin
  App := '';
  Vr  := False;
  For c1 := 1 to Length(Num) Do
  Begin
    if (Num[c1]>='0')and(Num[c1]<='9')or(Num[c1]='.')  then
    Begin
      if (Num[c1]='.') Then
      Begin
        if  (Not Vr) Then Vr := True
        else Exit;
      End;
      App := App + Num[c1];
    End;
  End;
  Str_Op2 := App;
End;

(******************************************************************************
 * Add                                                                        *
 ******************************************************************************)
Function TAcOperationString.Add : String;
Var
    Lunghezza : Integer;
    Risultato,
    App1,
    App2      : String;
Begin
  App1 := Valore1;
  App2 := Valore2;
  Lunghezza := Length(App1);
  if (Lunghezza<Length(App2)) then Lunghezza := Length(App2);
  if (Lunghezza=0) then
  Begin
    Risultato := '0'
  End
  Else
  Begin
    Prepara_Stringhe(App1,App2);
    Risultato := Somma(App1,App2);
  End;
  Add := Risultato;
End;

(******************************************************************************
 * Sub                                                                        *
 ******************************************************************************)
Function TAcOperationString.Sub : String;
Var
    Lunghezza : Integer;
    Risultato,
    App1,
    App2      : String;
Begin
  App1 := Valore1;
  App2 := Valore2;
  Lunghezza := Length(App1);
  if (Lunghezza<Length(App2)) then Lunghezza := Length(App2);
  if (Lunghezza=0) then
  Begin
    Risultato := '0'
  End
  Else
  Begin
    Prepara_Stringhe(App1,App2);
    Risultato := Sottrazione(App1,App2);
  End;
  Sub := Risultato;
End;

(******************************************************************************
 * Multiply                                                                   *
 ******************************************************************************)
Function TAcOperationString.Multiply : String;
Var
    Lunghezza,
    c1,
    c2       : Integer;
    Risultato,
    Parziale,
    App1,
    App2      : String;
    Decimali  : Integer; // Numero cifre decimali
Begin
  App1 := Valore1;
  App2 := Valore2;
  Prepara_Stringhe(App1,App2);

//******** conta le cifre decimali *********
  Decimali := 0;
  c1:=Pos('.',App1);
  if (c1>0) then Decimali := Length(App1)-c1;
  Delete(App1,c1,1);
  c1:=Pos('.',App2);
  if (c1>0) then Decimali := Decimali+Length(App2)-c1;
  Delete(App2,c1,1);

  Lunghezza := Length(App1);
  if (Lunghezza<Length(App2)) then Lunghezza := Length(App2);
  if (Lunghezza=0) then
  Begin
    Risultato := '0'
  End
  Else
  Begin
    Risultato := '0';
    For c1 := Length(App2) DownTo 1 do
    Begin
      Parziale := '0';
      For c2 := 1 to Ord(App2[c1])-$30 do
      Begin
        Prepara_Stringhe(Parziale,App1);
        Parziale := Somma(App1,Parziale);
      End;
      For c2 := c1 to Length(App2)-1 do Parziale := Parziale +'0';
      Prepara_Stringhe(Parziale,Risultato);
      Risultato := Somma(Parziale,Risultato);
    End;
    if (Decimali>0) Then Insert('.',Risultato,Length(Risultato)-Decimali+1);
  End;
  Multiply := Toglie_Zero(Risultato);
End;


(******************************************************************************
 * Prepara_Stringhe                                                           *
 ******************************************************************************)
Function TAcOperationString.Prepara_Stringhe(Var App1,App2 : String):Integer;
Var c1,c2 : Integer;
Begin
//******** Rende le stringhe lungue uguali aggiungendo degli 0 alla fine ********
  c2 := Pos('.',App2)-Pos('.',App1);
  if (c2<>0) Then
  Begin
    For c1 := 1 to c2 do App1 := '0' + App1;
  End
  Else
  Begin
    c2 := Length(app1);
    For c1 := c2 to Length (app2)-1 do App1 := '0' + App1;
  End;

  c2 := Pos('.',App1)-Pos('.',App2);
  if (c2<>0) Then
  Begin
    For c1 := 1 to c2 do App2 := '0' + App2;
  End
  Else
  Begin
    c2 := Length(app2);
    For c1 := c2 to Length (app1)-1 do App2 := '0' + App2;
  End;
//******** in caso di numero con virgola **********
//******** sistema i decimali            **********
  c2 := Pos('.',App2);
  if (c2<>0) Then
  Begin
    c2 := Length(app1);
    For c1 := c2 to Length (app2)-1 do App1 := App1 + '0';
  End;

  c2 := Pos('.',App1);
  if (c2<>0) Then
  Begin
    c2 := Length(app2);
    For c1 := c2 to Length (app1)-1 do App2 := App2 + '0';
  End;

//********* Aggiungo un zero all'inizio *********
//********* da usare eventualmente per  *********
//********* il riporto                  *********
  App1 := '0'+App1;
  App2 := '0'+App2;
  Prepara_Stringhe := Length(App1);

End;

(******************************************************************************
 * Somma                                                                      *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Num1      Primo operatore                                                  *
 * Num2      Secondo operatore                                                *
 *                                                                            *
 * P.S. Gli operatori devonoavere la stessa lunghezza, se non sono uguali     *
 *      vanno riempiti con degli '0' a sinistra                               *
 ******************************************************************************)
Function TAcOperationString.Somma(num1,num2:String):String;
Var C1,
    c2,
    Lunghezza,
    Riporto   : Integer;
    Risultato : String;
Begin
//******** Azzera il risultato *******
  Lunghezza := Length(Num1);
  For c1 := 1 to Lunghezza do Risultato := Risultato + '0';
//****** Esegue la somma *******
  Riporto := 0;
  For c1 := Lunghezza Downto 1 do
  Begin
    if (Num1[c1]<>'.') then
    Begin
      c2 := Ord(Num1[c1])-Ord('0')+Ord(Num2[c1])-Ord('0')+Riporto;
      Riporto := 0;
      if (c2>9) then
      Begin
        Riporto := 1;
        Dec(c2,10);
      End;
      Risultato[c1] := Chr($30+c2);
    End
    Else Risultato[c1]:= Num1[c1];
  End;
  While(Risultato<>'') Do
  Begin
    if (Risultato[1]='0') Then Delete(Risultato,1,1)
    Else Break;
  End;
  Somma := Risultato;
End;

(******************************************************************************
 * Sottrazione                                                                *
 *                                                                            *
 * Nome      Descrizione                                                      *
 * --------- ---------------------------------------------------------------- *
 * Num1      Primo operatore                                                  *
 * Num2      Secondo operatore                                                *
 *                                                                            *
 * P.S. Gli operatori devonoavere la stessa lunghezza, se non sono uguali     *
 *      vanno riempiti con degli '0' a sinistra                               *
 ******************************************************************************)
Function TAcOperationString.Sottrazione(num1,num2:String):String;
Var C1,
    c2,
    Lunghezza,
    Riporto   : Integer;
    Risultato,
    App       : String;
    Inverte   : Boolean;
Begin
//******** Azzera il risultato *******
  Lunghezza := Length(Num1);
  For c1 := 1 to Lunghezza do Risultato := Risultato + '0';
  Inverte := False;
  if (Maggiore(num1,num2)=1) then
  Begin
    App  := Num1;
    Num1 := Num2;
    Num2 := App;
    Inverte := True;
  End;
//****** Esegue la somma *******
  Riporto := 0;
  For c1 := Lunghezza Downto 1 do
  Begin
    if (Num1[c1]<>'.') then
    Begin
      c2 := Ord(Num1[c1])-Ord(Num2[c1])-Riporto;
      Riporto := 0;
      if (c2<0) then
      Begin
  //      if (not prestito_per_sottrazione(Num1,c1-1)) then
        Riporto := 1;
  //      else Inc(c2);
  //      c2 := Abs(c2);

        Inc(c2,10);
      End;
      Risultato[c1] := Chr($30+c2);
    End
    Else Risultato[c1]:=Num1[c1];
  End;
  While(Risultato<>'') Do
  Begin
    if (Risultato[1]='0') Then Delete(Risultato,1,1)
    Else Break;
  End;
  if (Inverte) then Risultato := '-'+Risultato;
  Sottrazione := Risultato;
End;

(******************************************************************************
 * Maggiore                                                                   *
 *                                                                            *
 * Restituisce                                                                *
 *                                                                            *
 * -1  n1 > n2                                                                *
 *  0  n2 = n2                                                                *
 * +1  n2 > n1                                                                *
 ******************************************************************************)
function TAcOperationString.Maggiore(n1,n2:string):Integer;
Var c1 : Integer;
Begin
  For c1 := 1 to length(n1) Do
  Begin
    if (n1[c1]>n2[c1]) then
    Begin
      Maggiore := -1;
      exit;
    End;
    if (n1[c1]<n2[c1]) then
    Begin
      Maggiore := +1;
      exit;
    End;
  End;
  Maggiore := 0;
End;



function TAcOperationString.prestito_per_sottrazione(Var App1:String;indice:Integer):Boolean;
Var c1 : Integer;
Begin
  For c1 := Indice downto 1 do
  Begin
    if (App1[c1]>'1') then
    Begin
      Dec(App1[c1]);
      prestito_per_sottrazione := True;
      exit;
    End;
  End;
  prestito_per_sottrazione := False;

End;


(******************************************************************************
 * Toglie_Zero                                                                *
 ******************************************************************************)
Function TAcOperationString.Toglie_Zero(Valore : String):String;
Begin
  While(Valore<>'') Do
  Begin
    if (Valore[1]='0') Then Delete(Valore,1,1)
    Else Break;
  End;
  While(Valore<>'') Do
  Begin
    if (Valore[Length(Valore)]='0') Then Delete(Valore,Length(Valore),1)
    Else Break;
  End;
  Toglie_Zero := Valore;
End;
End.
