(******************************************************************************
 * AcQrCrtrl                                                              *
 ******************************************************************************)
unit AcQrCtrl;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses Controls, QuickRep, Classes, Graphics, Windows, Messages, AcQrCustCtrl;

(******************************************************************************
 * Type                                                                       *
 ******************************************************************************)
Type
  pgPosizione = (pgLeft,pgRight);
  TACQRGreca_1 = class(TACQRCustomGraph)
  Private
     Num_Gobbe     : Integer;
     Dim_Gobbe     : Integer;
     Pos_Gobbe     : pgPosizione;
  Protected
     Procedure Set_Num_Gobbe(Num:Integer);
     Procedure Set_Dim_Gobbe(Num:Integer);
     Procedure Set_Pos_Gobbe(Pos:pgPosizione);
  Public
     procedure Paint; override;
     procedure WMSize(var Msg: TWMSize); message WM_SIZE;
     constructor Create(AOwner : TComponent); override;
  Published
     property Height;
     property Left;
     property Top;
     property Visible;
     property Width;
     property Brush;
     property Pen;
     Property NumeroGobbe     : Integer     Read Num_Gobbe   Write Set_Num_Gobbe;
     Property DimensioneGobbe : Integer     Read Dim_Gobbe   Write Set_Dim_Gobbe;
     Property PosizioneGobbe  : pgPosizione Read Pos_Gobbe   Write Set_Pos_Gobbe;
  End;
(******************************************************************************
 * Implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Uses                                                                       *
 ******************************************************************************)
Uses SysUtils;

(******************************************************************************
 * Paint                                                                      *
 ******************************************************************************)
procedure TACQRGreca_1.Paint;
Var c1,c2   : Integer;
    Altezza,c3 : Real;

Begin
  Linee.Clear;
//********** Destra **********
  if (PosizioneGobbe=pgRight) Then
  Begin
    Linee.Add('L'+IntToStr(0)+','+IntToStr(0));
    Linee.Add('L'+IntToStr(Width-DimensioneGobbe)+','+IntToStr(0));
    Altezza := (Height-1) / (NumeroGobbe*2);
    c2 := 0;
    c3 := 0;
    For c1 := 0 to NumeroGobbe*2 Do
    Begin
      c3 := Altezza * c1;
      Inc(c2);
      if (c2 mod 2 <> 0) then
        Linee.Add('L'+IntToStr(Width-DimensioneGobbe-1)+','+IntToStr(Round(c3)))
      else
        Linee.Add('L'+IntToStr(Width-1)+','+IntToStr(Round(c3)));
    End;
    Linee.Add('L'+IntToStr(0)+','+IntToStr(Round(c3)));
    Linee.Add('L'+IntToStr(0)+','+IntToStr(0));
  End
  Else
//********** Sinistra **********
  if (PosizioneGobbe=pgLeft) Then
  Begin
    Linee.Add('L'+IntToStr(Width-1)+','+IntToStr(0));
    Linee.Add('L'+IntToStr(DimensioneGobbe)+','+IntToStr(0));
    Altezza := (Height-1) / (NumeroGobbe*2);
    c2 := 0;
    c3 := 0;
    For c1 := 0 to NumeroGobbe*2 Do
    Begin
      c3 := Altezza * c1;
      Inc(c2);
      if (c2 mod 2 <> 0) then
        Linee.Add('L'+IntToStr(DimensioneGobbe)+','+IntToStr(Round(c3)))
      else
        Linee.Add('L'+IntToStr(0)+','+IntToStr(Round(c3)));
    End;
    Linee.Add('L'+IntToStr(Width-1)+','+IntToStr(Round(c3)));
    Linee.Add('L'+IntToStr(Width-1)+','+IntToStr(0));
  End;

  Inherited;
End;

(******************************************************************************
 * WMSize                                                                     *
 ******************************************************************************)
procedure TACQRGreca_1.WMSize(var Msg: TWMSize);
Begin
  Inherited;
  if (Msg.Width<50) then Msg.Width := 50;
  if (Msg.Height<50) then Msg.Height:= 50;
  Invalidate;
End;

(******************************************************************************
 * Set_Num_Gobbe                                                              *
 ******************************************************************************)
Procedure TACQRGreca_1.Set_Num_Gobbe(Num:Integer);
Begin
  if (Num=0) Then Exit;
  Num_Gobbe := num;
  Invalidate;
End;

(******************************************************************************
 * Set_Dim_Gobbe                                                              *
 ******************************************************************************)
Procedure TACQRGreca_1.Set_Dim_Gobbe(Num:Integer);
Begin
  if (Num>0) Then
  Begin
    Dim_Gobbe := num;
    Invalidate;
  End;
  Invalidate;
End;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
constructor TACQRGreca_1.Create(AOwner : TComponent);
Begin
 Inherited;
 NumeroGobbe       := 5;
 DimensioneGobbe   := 20;
 PosizioneGobbe    := pgRight;
End;

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
Procedure TACQRGreca_1.Set_Pos_Gobbe(Pos:pgPosizione);
Begin
  Pos_Gobbe := Pos;
  Invalidate;
End;
end.

