
(******************************************************************************
 * ACQrLabel                                                                  *
 ******************************************************************************)
unit AcQrLabel;

(******************************************************************************
 * Interface                                                                  *
 ******************************************************************************)
 interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, AcProcDeclare, quickrep, Math;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACQrLabel = class(TQRLabel)
  private
    { Private declarations }
  protected
    { Protected declarations }
    Mio_Angolo : Integer;
    Procedure Set_Angolo(x:Integer);

  public
    { Public declarations }
    Procedure Paint; Override;
    procedure Print(X, Y: Integer); override;
    procedure DoDrawText(var Rect: TRect; Flags: Word);
    constructor Create(AOwner: TComponent); Override;
    procedure Disegna(Video:Boolean;xxx,yyy:Integer;fnzX,fnzY:AcFunMolt;Cnv:TCanvas);
    Function Moltiplica_per_Uno(Numero:Longint):Longint;
  published
    { Published declarations }
    Property Angle : Integer Read Mio_Angolo Write Set_Angolo;
    Property Caption;
    Property Font;
    Property AutoSize;
//    Property align;
  end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * constructor                                                                *
 ******************************************************************************)
constructor TAcQrLabel.Create(AOwner: TComponent);
Begin
  Inherited;
  //Trasparent := True;

End;


(******************************************************************************
 * DoDrawText                                                                 *
 ******************************************************************************)
procedure TAcQrLabel.DoDrawText(var Rect: TRect; Flags: Word);
var
  Text: string;
begin
  Text := GetLabelText;
  Canvas.Font := Font;
  if not Enabled then Canvas.Font.Color := clGrayText;
  DrawText(Canvas.Handle, PChar(Text), Length(Text), Rect, Flags);
end;



(******************************************************************************
 * Print                                                                      *
 ******************************************************************************)
procedure TAcQrLabel.Print(X, Y: Integer);
begin
 Disegna(False,left+x,top+y,ParentReport.XPos,ParentReport.YPos,QRPrinter.Canvas);
End;

(******************************************************************************
 * paint                                                                      *
 ******************************************************************************)
procedure TAcQrLabel.paint;
begin
 Disegna(True,0,0,Moltiplica_per_Uno,Moltiplica_per_Uno,Canvas);
End;

(******************************************************************************
 * Set_Angolo                                                                 *
 ******************************************************************************)
Procedure TAcQrLabel.Set_Angolo(x:Integer);
Begin
  Mio_Angolo := x;
  Invalidate;
End;


procedure TAcQrLabel.Disegna(Video:Boolean;xxx,yyy:Integer;fnzX,fnzY:AcFunMolt;Cnv:TCanvas);
var
 Fnt     : hFont;
 LogFont : TLogFont;
// F       : TFont;
 XX,
 YY      : Integer;
 Angolo  : Integer;
 re      : TRect;
 txt     : String;
begin

  xx := 0; // Azzerate per togliere il messaggio di Warning
  yy := 0;

  Angolo := Angle mod 360; //
  if(Angolo<0) then Angolo := Angolo + 360;

  if not Transparent then
  begin

    Canvas.Brush.Color := Color;
    Canvas.Brush.Style := bsSolid;
    Canvas.FillRect(ClientRect);
  end;
  Cnv.Font.Assign(Font);
  FillChar(LogFont, SizeOf(LogFont), 0);

  GetObject(Font.Handle, SizeOf(LogFont), Addr(LogFont));
  Logfont.lfOutPrecision := OUT_TT_ONLY_PRECIS;  { Request TrueType precision }
  Logfont.lfEscapement   := Angolo*10;
//
  With LogFont do
  Begin

    if (Assigned(fnzX)) then
         lfHeight      := fnzX(-Font.Height)
    else lfHeight      := -Font.Height;
    lfOutPrecision     := OUT_DEFAULT_PRECIS;
    lfClipPrecision    := CLIP_DEFAULT_PRECIS;
//    lfOutPrecision     := OUT_TT_ONLY_PRECIS;
    lfCharSet          := OEM_CHARSET;
    StrPCopy(lfFaceName, Font.Name);

//    lfOrientation := 0;


//    lfEscapement  := Angolo*10;
//    lfWeight      := FW_BOLD;

//    StrPCopy(lfFaceName,Font.Name);
  End;
  Fnt := CreateFontIndirect(LogFont);


  Cnv.Brush.Color := Color;

  Cnv.Brush.Style := bsClear;
  Cnv.Font.Handle := Fnt;
//************************
//********** XX **********
//************************
//  Size1 := Round(Cnv.Textwidth(Caption)*Cos(Angle*3.14/180));
//  if (Alignment=taLeftJustify) Then
  begin
//******** 000..090 **********
    if (Angolo<=90) then
    begin

      if (Alignment=taLeftJustify) then
      begin
        XX := 0;
      end;

      if (Alignment=taRightJustify) then
      begin
        XX :=fnzX(ClientWidth)-
             Round(Cnv.TextWidth(Caption)*cos(degtorad(angolo)))-
             Round(Cnv.TextHeight(Caption)*Sin(degtorad(angolo)));
      end;
      if (Alignment=taCenter) then
      begin
        XX :=fnzX(ClientWidth)-
             Round(Cnv.TextWidth(Caption)*cos(degtorad(angolo)))-
             Round(Cnv.TextHeight(Caption)*Sin(degtorad(angolo)));
        XX := XX div 2;
      end;

    end
//******** 090..180 **********
    Else if (Angolo<=180) then
    begin
      if (Alignment=taLeftJustify) then
      begin
        xx := fnzX(ClientWidth)-Round(Cnv.Textheight(Caption)*sin(degtorad(angolo)));
      end;

      if (Alignment=taRightJustify) then
      begin
        xx := -Round(cnv.textwidth(Caption)*cos(degtorad(angolo)));
      end;
      if (Alignment=taCenter) then
      begin
        XX :=fnzX(clientwidth)-Round(Cnv.Textheight(Caption)*sin(degtorad(angolo)))-
             Round(cnv.textwidth(Caption)*cos(degtorad(angolo)));;
        XX := XX div 2;
      end;

    end
//******** 180..270 **********
    Else if (Angolo<=270) then
    begin

      if (Alignment=taLeftJustify) then
      begin
        xx := fnzX(ClientWidth);//+Round(Cnv.Textheight(Caption)*sin(degtorad(angolo)));
      end;

      if (Alignment=taRightJustify) then
      begin
        xx := -Round(cnv.textwidth(Caption)*cos(degtorad(angolo)))-
              Round(cnv.textheight(Caption)*sin(degtorad(angolo)));
      end;
      if (Alignment=taCenter) then
      begin
        xx := fnzX(ClientWidth)-
              Round(cnv.textwidth(Caption)*cos(degtorad(angolo)))-
              Round(cnv.textheight(Caption)*sin(degtorad(angolo)));
        xx := xx div 2;
      end;

    end
    Else
//******** 270..360 **********
    begin
      if (Alignment=taLeftJustify) then
      begin
        XX    := -Round(Cnv.Textheight(Caption)*sin(degtorad(angolo)));
      end;

      if (Alignment=taRightJustify) then
      begin
        xx := FnzX(ClientWidth)-Round(cnv.textwidth(Caption)*cos(degtorad(angolo)))-
              0*Round(cnv.textheight(Caption)*sin(degtorad(angolo)));
      end;
      if (Alignment=taCenter) then
      begin
        XX := -Round(Cnv.Textheight(Caption)*sin(degtorad(angolo)))+
              FnzX(ClientWidth)-Round(cnv.textwidth(Caption)*cos(degtorad(angolo)))-
              0*Round(cnv.textheight(Caption)*sin(degtorad(angolo)));
        xx := xx div 2;
      end;


    end;


  End;

//************************
//********** YY **********
//************************
//******** 000..090 **********
  if (Angolo<=90) then
  begin
    if (Alignment=taLeftJustify) then
    begin
       yy := fnzY(ClientHeight)-
             round(Cnv.TextHeight(Caption)*cos(degtorad(angolo)));

    end;
    if (Alignment=taRightJustify) then
    begin
      yy := Round(Cnv.TextWidth(Caption)*sin(degtorad(angolo)));
    end;
    if (Alignment=taCenter) then
    begin
      yy := fnzY(ClientHeight)-
            round(Cnv.TextHeight(Caption)*cos(degtorad(angolo)))+
            Round(Cnv.TextWidth(Caption)*sin(degtorad(angolo)));
      yy := yy div 2;
    end;

  End
//******** 090..180 **********
  Else if (Angolo<=180) then
  begin
    if (Alignment=taLeftJustify) then
    begin
      yy := fnzY(ClientHeight);
    end;
    if (Alignment=taRightJustify) then
    begin
      yy := Round(cnv.textwidth(Caption)*sin(degtorad(angolo)))-
            Round(Cnv.Textheight(Caption)*cos(degtorad(angolo)));

    end;
    if (Alignment=taCenter) then
    begin
      yy := fnzY(ClientHeight)+
            Round(cnv.textwidth(Caption)*sin(degtorad(angolo)))-
            Round(Cnv.Textheight(Caption)*cos(degtorad(angolo)));
      yy := yy div 2;
    end;

  end
//******** 180..270 **********
  Else if (Angolo<=270) then
  begin
    if (Alignment=taLeftJustify) then
    begin
      yy := 0-round(Cnv.textheight(Caption)*cos(degtorad(angolo)));
    end;
    if (Alignment=taRightJustify) then
    begin
      yy := fnzY(ClientHeight)+
            Round(cnv.textwidth(Caption)*sin(degtorad(angolo)));

    end;
    if (Alignment=taCenter) then
    begin
      yy := 0-round(Cnv.textheight(Caption)*cos(degtorad(angolo)))+
            fnzY(ClientHeight)+
            Round(cnv.textwidth(Caption)*sin(degtorad(angolo)));
      yy := yy div 2;
    end;

  end
//******** 270..360 **********
  Else
  begin
    if (Alignment=taLeftJustify) then
    begin
      yy := 0;//+Round(Cnv.TextHeight(Caption)*Cos(degtorad(angolo)));
    end;
    if (Alignment=taRightJustify) then
    begin
      yy := fnzY(ClientHeight)+
            Round(cnv.textwidth(Caption)*sin(degtorad(angolo)))-
            Round(cnv.textheight(Caption)*cos(degtorad(angolo)));

    end;
    if (Alignment=taCenter) then
    begin
      yy := 0+
            fnzY(ClientHeight)+
            Round(cnv.textwidth(Caption)*sin(degtorad(angolo)))-
            Round(cnv.textheight(Caption)*cos(degtorad(angolo)));

      yy := yy div 2;
    end;

  end;

  if ((Assigned(FnzX))and(Assigned(fnzY))) then
  begin
    txt := Caption;
    re := rect(fnzX(xxx), fnzY(yyy),fnzX(xxx+width), fnzY(yyy+height));


    ExtTextOut(cnv.Handle, fnzX(xxx)+xx, fnzY(yyy)+yy, ETO_CLIPPED, @re,
     @txt[1], Length(txt), nil);

//     cnv.Rectangle(fnzX(xxx), fnzY(yyy),fnzX(xxx+width), fnzY(yyy+height));




  end
  else Cnv.TextOut(xxx+XX, yyy+YY, Caption);
//    Cnv.TextOut((xxx+xx), (yyy+height-YY), Caption);


//  F. Free;
//  DeleteObject(Fnt);
end;

(******************************************************************************
 * Moltiplica_Per_Uno                                                         *
 ******************************************************************************)
Function TAcQrLabel.Moltiplica_per_Uno(Numero:Longint):Longint;
Begin
  Moltiplica_per_Uno := Numero;
End;


end.
