(******************************************************************************
 * ACQuickSort                                                                *
 ******************************************************************************)
unit ACQuickSort;

(******************************************************************************
 * interface                                                                  *
 ******************************************************************************)
interface

(******************************************************************************
 * uses                                                                       *
 ******************************************************************************)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AcProcDeclare;

(******************************************************************************
 * type                                                                       *
 ******************************************************************************)
type
  TACSort = (TACSString,TACSInteger);
  TACQuickSort = class(TComponent)
  private
    { Private declarations }
  protected
    temp_int_a,
    temp_int_b : Integer;
    temp_str_a,
    temp_str_b : String;

    { Protected declarations }
    f_Sort           : TACSort;
    f_OnWriteInteger : TACQSWriteInteger;
    f_OnReadInteger  : TACQSReadInteger;
    f_OnWriteString : TACQSWriteString;
    f_OnReadString  : TACQSReadString;

//    f_OnReadReal     : TACQSWriReal;

    procedure Ordina(basso, alto: Integer);
    procedure OrdinaStr(basso, alto: Integer);
    function Get_Numero(ndx:Integer;var num : Integer):Integer;
    function Get_Stringa(ndx:Integer;var num : String):String;


  public
    { Public declarations }
    Procedure Sort(Numero:Integer);
    constructor Create(AOwner: TComponent); Override;
  published
    { Published declarations }
    property SortProperty   : TACSort Read f_Sort Write f_Sort;
    property OnReadInteger  : TACQSReadInteger  Read f_OnReadInteger   Write f_OnReadInteger;
    property OnWriteInteger : TACQSWriteInteger Read f_OnWriteInteger  Write f_OnWriteInteger;
    property OnReadString   : TACQSReadString  Read f_OnReadString   Write f_OnReadString;
    property OnWriteString  : TACQSWriteString Read f_OnWriteString  Write f_OnWriteString;

//    property OnNeedReal    : TACQSNeedReal      Read f_OnNeedReal    Write f_OnNeedReal;

  end;


(******************************************************************************
 * implementation                                                             *
 ******************************************************************************)
implementation

(******************************************************************************
 * Constructor                                                                *
 ******************************************************************************)
 constructor TACQuickSort.Create(AOwner: TComponent);
begin
  Inherited;
  OnReadInteger  := Nil;
  OnWriteInteger := Nil;
  SortProperty   := TACSInteger;
end;



//Procedure Sort(var v: List; Lo, Hi: Integer);
(******************************************************************************
 * Get_Numero                                                                 *
 ******************************************************************************)
function TACQuickSort.Get_Numero(ndx:Integer;var num : Integer):Integer;
Var x : Integer;
begin
  OnReadInteger(ndx,x);
  num := x;
  Get_Numero := x;
end;

(******************************************************************************
 * Get_Numero                                                                 *
 ******************************************************************************)
function TACQuickSort.Get_Stringa(ndx:Integer;var num : String):String;
Var x : String;
begin
  OnReadString(ndx,x);
  num := x;
  Get_Stringa := x;
end;

(******************************************************************************
 * Ordina                                                                     *
 ******************************************************************************)
procedure TACQuickSort.Ordina(basso, alto: Integer);
//var v : array[1..10] of integer;
var
  c1, c2, Perno : integer;
begin
  c1    := basso;
  c2    := alto;
  Perno := Get_Numero((basso+alto) DIV 2,temp_int_a);
  repeat
    while Get_Numero(c1,temp_int_a) < perno do c1 := c1 + 1;
    while perno < Get_Numero(c2,temp_int_b) do c2 := c2 - 1;
    if c1 <= c2 then
    begin
      if (Assigned(OnWriteInteger)) then
      begin
        OnWriteInteger(c1,temp_int_b);
        OnWriteInteger(c2,temp_int_a);
      end;
      c1 := c1 + 1;
      c2 := c2 - 1;
    end;
  until c1 > c2;
  if basso < c2 then Ordina(basso, c2);
  if c1 < alto then Ordina(c1, alto);
end;
(******************************************************************************
 * OrdinaStr                                                                  *
 ******************************************************************************)
procedure TACQuickSort.OrdinaStr(basso, alto: Integer);
//var v : array[1..10] of integer;
var
  c1, c2  : integer;
  Perno   : String;
begin
  c1    := basso;
  c2    := alto;
  Perno := Get_Stringa((basso+alto) DIV 2,temp_str_a);
  repeat
    while Get_Stringa(c1,temp_str_a) < perno do c1 := c1 + 1;
    while perno < Get_Stringa(c2,temp_str_b) do c2 := c2 - 1;
    if c1 <= c2 then
    begin
      if (Assigned(OnWriteInteger)) then
      begin
        OnWriteString(c1,temp_str_b);
        OnWriteString(c2,temp_str_a);
      end;
      c1 := c1 + 1;
      c2 := c2 - 1;
    end;
  until c1 > c2;
  if basso < c2 then Ordina(basso, c2);
  if c1 < alto then Ordina(c1, alto);
end;

(******************************************************************************
 * Sort                                                                       *
 ******************************************************************************)
Procedure TACQuickSort.Sort(Numero:Integer);
begin
  If (SortProperty=TACSInteger) Then
    if (Assigned(OnReadInteger)) then Ordina(0,Numero-1);
  If (SortProperty=TACSInteger) Then
    if (Assigned(OnReadString)) then OrdinaStr(0,Numero-1);

end;

  //begin QuickSort;
  //Sort(Lo,Hi);
  //end;
end.
