(******************************************************************************
 *                                                                            *
 ******************************************************************************)
unit fn_prestiti;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
interface

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
Uses Classes;

(******************************************************************************
 *                                                                            *
 ******************************************************************************)

function prestiti_aggiunge(Socio, Libro:integer;Titolo,Autore,Genere:String):integer;

procedure prestiti_Carica_Browse(Socio:Integer;br:TStrings);

(******************************************************************************
 *                                                                            *
 ******************************************************************************)
implementation


(******************************************************************************
 *                                                                            *
 ******************************************************************************)
Uses Vari, Sysutils, fn_book, Form_main;


(******************************************************************************
 * Costanti                                                                   *
 ******************************************************************************)
 Const PRESTITI_EXT            = '.pre';
       PRESTITI_SUBCARTELLA    = 'soci\';
       PRESTITI_INI_SEZIONE    = 'Prestito';
       PRESTITI_INI_LIBRO      = 'Codice libro';
       PRESTITI_INI_DATA       = 'Data';
       PRESTITI_INI_TITOLO     = 'Titolo';
       PRESTITI_INI_AUTORE     = 'Autore';
       PRESTITI_INI_GENERE     = 'Genere';

{******************************************************************************
 * prestiti nome cartella                                                     *
 *                                                                            *
 * Restituisce il nome della cartella in cui registrare i prestiti            *
 ******************************************************************************}
function prestiti_nome_cartella:String;
Begin
  prestiti_nome_cartella := completa_percorso(cur_path)+PRESTITI_SUBCARTELLA;
end;


(******************************************************************************
 * Prestiti_Prossimo                                                          *
 *                                                                            *
 * Ottiene il codice da inserire per scrivere un nuovo prestito               *
 ******************************************************************************)
function prestiti_prossimo(Socio:integer):integer;
Var
    c1,c2  : Integer;
Begin
  //c2 := 1;
  Form1.B_Ini.FileName := prestiti_nome_cartella+trim(inttostr(socio))+PRESTITI_EXT;
  Try
    c2 := 1;
    c1 := 1;
    while(c2<>0) do
    begin
      c2 := Form1.B_Ini.ReadInteger(PRESTITI_INI_SEZIONE+Trim(IntToStr(c1)),PRESTITI_INI_LIBRO,0);
      if(c2<>0) then c1 := c1 + 1;
    end;
  Finally
//    Ini.Free;
  end;
  prestiti_prossimo := c1;
End;

(******************************************************************************
 * prestito_aggiunge                                                          *
 *                                                                            *
 * Nome          Descrizione                                                  *
 * ------------- ------------------------------------------------------------ *
 * Socio         Codice del socio                                             *
 * Libro         Codice del libro                                             *
 *                                                                            *
 * Restituisce                                                                *
 *    0: Ok                                                                   *
 *    1: File non esiste                                                      *
 *    2: Errore generico                                                      *
 *    3: Sole lettura                                                         *
 ******************************************************************************)
function prestiti_aggiunge(Socio, Libro:integer;Titolo,Autore,Genere:String):integer;
Var //Ini : TIniFile;
    codice_prestito : integer;
    fl              : Integer;
Begin
  fl :=  stato_file(prestiti_nome_cartella+trim(inttostr(socio))+PRESTITI_EXT);
  if (fl<>0)and(fl<>1) then
  begin
     prestiti_aggiunge := fl;
     exit;

  end;

  Form1.B_Ini.FileName := prestiti_nome_cartella+trim(inttostr(socio))+PRESTITI_EXT;
  Try
    codice_prestito := prestiti_prossimo(socio);
    Form1.B_Ini.WriteInteger(PRESTITI_INI_SEZIONE+Trim(IntToStr(codice_prestito)),PRESTITI_INI_LIBRO,Libro);
    Form1.B_Ini.WriteString(PRESTITI_INI_SEZIONE+Trim(IntToStr(codice_prestito)),PRESTITI_INI_DATA,DateToStr(Now));

    Form1.B_Ini.WriteString(PRESTITI_INI_SEZIONE+Trim(IntToStr(codice_prestito)),PRESTITI_INI_TITOLO,Titolo);
    Form1.B_Ini.WriteString(PRESTITI_INI_SEZIONE+Trim(IntToStr(codice_prestito)),PRESTITI_INI_AUTORE,Autore);
    Form1.B_Ini.WriteString(PRESTITI_INI_SEZIONE+Trim(IntToStr(codice_prestito)),PRESTITI_INI_GENERE,Genere);

  Finally
    //Ini.Free;
  end;
  prestiti_aggiunge := 0;
End;


(******************************************************************************
 * Prestiti_Carica_Browse                                                     *
 *                                                                            *
 ******************************************************************************)
procedure prestiti_Carica_Browse(Socio:Integer;br:TStrings);
Var //Ini : TIniFile;
    Lista           : TStringList;
    Libro           : Integer;
    Data,
    Fuori,
    Titolo,
    Autore,
    Genere          : String;
    Corrente        : Integer;
    app1            : rec_book;
    Numero          : Integer;
Begin
  Lista := TStringList.Create;
  Form1.B_Ini.FileName := prestiti_nome_cartella+trim(inttostr(socio))+PRESTITI_EXT;

  Libro    := 1;
  Corrente := 1;
  Numero   := 0;


  Try

    While(Libro>0) do
    begin
      Libro   := Form1.B_Ini.ReadInteger(PRESTITI_INI_SEZIONE+Trim(IntToStr(Corrente)),PRESTITI_INI_LIBRO,0);
      Data    := Form1.B_Ini.ReadString(PRESTITI_INI_SEZIONE+Trim(IntToStr(Corrente)),PRESTITI_INI_DATA,'');
      Titolo  := Form1.B_Ini.ReadString(PRESTITI_INI_SEZIONE+Trim(IntToStr(Corrente)),PRESTITI_INI_TITOLO,'');
      Autore  := Form1.B_Ini.ReadString(PRESTITI_INI_SEZIONE+Trim(IntToStr(Corrente)),PRESTITI_INI_AUTORE,'');
      Genere  := Form1.B_Ini.ReadString(PRESTITI_INI_SEZIONE+Trim(IntToStr(Corrente)),PRESTITI_INI_GENERE,'');

      if (Libro>0) then
      begin
        if (book_cerca_per_codice(app1,IntToStr(Libro),False)>0) then
        begin
          if (app1.Codice_prestito>0) then
          begin
            if (app1.codice_prestito=socio)and(data=app1.data_prestito) then Fuori := 'Preso'
            else Fuori := 'Fuori';
          end
          else Fuori := '';
        end
        else
        begin
          Fuori := '#####';
          App1.Posizione := '';
        end;
        Lista.Insert(0,Format_Str(IntToStr(Libro),7,False) + ' ' + // Codice
                       Format_Str(Titolo,16,False) + ' ' +    // Titolo
                       Format_Str(Autore,13,False) + ' ' +    // Autore
                       Format_Str(Genere,11,False) + ' ' +    // Autore
                       Format_Str(Data,10,False) + ' ' +           // Data
                       Format_Str(App1.Posizione,6,False) + ' ' +  // Data

                       Format_Str(Fuori,6,False));           // Data
        Numero := Numero + 1;
        Corrente := Corrente + 1;
      end;
    end;

  Finally
    Lista.insert(0,'------- ---------------- ------------- ----------- ---------- ------ ------');
    Lista.insert(0,'Codice  Titolo           Autore        Genere      Data       Pos    Stato');


    if (Numero=0) Then Lista.Add('Nessun libro prestato');
    Br.Assign(Lista);
    Lista.Free;
    //Ini.Free;
  end;

End;



end.
